%% PROBLEM 1

%% Magnetization curve of the machine
%The magnetization curve for the dc motor at a constant speed of 1200 r.p.m is:

load problema1.mat
image = imread('problema1.jpg');
imshow(image)


%% Initials Values 

disp('*INITIALS VALUES*')
V = input('Nominal voltage (V) = ');
I = input('Nominal current (A) = ');
rf = input('Field resistance (ohms) = ');
ra = input('Armature resistance (ohms) = ');

%% SECTION 1
% Whit an adjustable resistance, what is the rotational speed of the motor at no-load conditions?
disp('*ROTATIONAL SPEED NO-LOAD*')
r_ad = input('Adjustable resistance (ohms) = ');
E_a = V;
Ie_a = (V/(rf+r_ad));
Ea_a = interp1(Ie,Ea,Ie_a,'spline');
disp(['new electromotive force is =',num2str(Ea_a)]);
n_a = ((E_a*n0)/Ea_a);
disp(['rotational speed no-load = ',num2str(n_a),' r/min ']);


%% SECTION 2
%2.1
% Assuming no armature reaction, what is the speed of the motor at full load?
disp('*ROTATIONAL SPEED FULL LOAD (no armature reaction)*')
Ia_b = I-Ie_a;
E_b = V-(ra*Ia_b);
n_b = (E_b*n_a)/E_a;
disp(['Rotational speed full load = ',num2str(n_b),'r/min']);

%2.2
% What is the speed regulation of the motor?
disp('SPEED REGULATION OF MOTOR')
Regulacion = ((n_a-n_b)/n_b)*100;
disp(['Speed regulation of motor = ',num2str(Regulacion),' % ']);

%% SECTION 3
% The motor is operating at full load and whit a new adjustable resistance, what is the new speed of the motor?
disp('*ROTATIONAL SPEED FULL LOAD*')
r_ad1 = input('Adjustable resistance (ohms) = ');
Ie_c = (V/(rf+r_ad1));
Ia_c = I-Ie_c;
E_c = V-(ra*Ia_c);
n_c = (E_c*n_b*Ie_a)/(E_b*Ie_c);
disp(['Rotational speed full load = ',num2str(n_c),'r/min']);

%% SECTION 4

disp('*ROTATIONAL SPEED FULL LOAD (armature reaction)*')
Nf = input('Number of turns on field = ');
Fi = input('The armature reaction (A-turns) = ');
Ie_d = Ie_a-(Fi/Nf);
Ia_d = I-Ie_d;
E_d = V-(ra*Ia_d);
n_d = (E_d*n_a*Ie_a)/(E_a*Ie_d);
disp(['Rotational speed full load = ',num2str(n_d),' r/min']);

%% SECTION 5
% Whit an adjustable resistance interval, what are the maximum and minimum no-load speeds possible with this motor?

disp('*MAXIMUM AND MINIMUM SPEED NO-LOAD*')

r_ad2 = input('Adjustable minimum  resistance = ');
r_ad3 = input('Adjustable maximum resistance = ');
Ie_min = V/(rf+r_ad3);
Ie_max = V/(rf+r_ad2);
Ea_min = interp1(Ie,Ea,Ie_min,'spline');
n_min = (Ea_min*n_a)/E_a;
disp(['minimum speed no-load = ',num2str(n_min),' r/min ']);
Ea_max = interp1(Ie,Ea,Ie_max,'spline');
n_max = (Ea_max*n_a)/E_a;
disp(['maximum speed no-load = ',num2str(n_max),' r/min ']);

%% SECTION 6
% What is the starting current of this machine if it is started by connecting it directly to the power supply?
disp('STARTING CURRENT')
I_s = V/ra;
disp(['The starting current of this machine is = ',num2str(I_s),' A ']);


%% SECTION 7
i_l = 1:2:I;
% Calculate the armature current for each load.
i_a = i_l - V / (rf + r_ad);
% Now calculate the internal generated voltage for
% each armature current.
e_a = V - i_a * ra;
% Calculate the armature reaction MMF for each armature
% current.
f_ar = (i_a / I) * Fi;
% Calculate the effective field current with and without
% armature reaction. Ther term i_f_ar is the field current
% with armature reaction, and the term i_f_noar is the
% field current without armature reaction.
i_f_ar = V / (rf + r_ad) - f_ar / Nf;
i_f_noar = V / (rf + r_ad);
% Calculate the resulting internal generated voltage at
% 1200 r/min by interpolating the motor's magnetization
% curve.
e_a0_ar = interp1(Ie,Ea,i_f_ar,'spline');
e_a0_noar = interp1(Ie,Ea,i_f_noar,'spline');
% Calculate the resulting speed from Equation (8-38).
n_ar = ( e_a ./ e_a0_ar ) * n0;
n_noar = ( e_a ./ e_a0_noar ) * n0;
% Calculate the induced torque corresponding to each
% speed from Equations (8-28) and (8-29).
t_ind_ar = e_a .* i_a ./ (n_ar * 2 * pi / 60);
t_ind_noar = e_a .* i_a ./ (n_noar * 2 * pi / 60);
% Plot the torque-speed curves
figure(1);
plot(t_ind_noar,n_noar,'b-','LineWidth',2.0);
hold on;
plot(t_ind_ar,n_ar,'k--','LineWidth',2.0);
xlabel('\bf\tau_{ind} (N-m)');
ylabel('\bf\itn_{m} \rm\bf(r/min)');
title ('\bfShunt DC Motor Torque-Speed Characteristic');
legend('No armature reaction','With armature reaction');
axis([ 0 250 800 1250]);
grid on;
hold off;